// PDO_ProtocolDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PDO_Protocol.h"
#include "PDO_ProtocolDlg.h"
#include "..\lib\i8123w.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPDO_ProtocolDlg dialog

CPDO_ProtocolDlg::CPDO_ProtocolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPDO_ProtocolDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPDO_ProtocolDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPDO_ProtocolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPDO_ProtocolDlg)
	DDX_Control(pDX, IDC_LIST_PDOLIST, m_pdolist);
	DDX_Control(pDX, IDC_EDIT_D7, m_d7);
	DDX_Control(pDX, IDC_EDIT_D6, m_d6);
	DDX_Control(pDX, IDC_EDIT_D5, m_d5);
	DDX_Control(pDX, IDC_EDIT_D4, m_d4);
	DDX_Control(pDX, IDC_EDIT_D3, m_d3);
	DDX_Control(pDX, IDC_EDIT_D2, m_d2);
	DDX_Control(pDX, IDC_EDIT_D1, m_d1);
	DDX_Control(pDX, IDC_EDIT_D0, m_d0);
	DDX_Control(pDX, IDC_EDIT_COBID, m_cobid);
	DDX_Control(pDX, IDC_COMBO_SLOT, m_slot);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_LEN, m_len);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_PDOW, m_btn_pdow);
	DDX_Control(pDX, IDC_BUTTON_PDOR, m_btn_pdor);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_btn_clear);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPDO_ProtocolDlg, CDialog)
	//{{AFX_MSG_MAP(CPDO_ProtocolDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_SLOT, OnSelchangeComboSlot)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_CBN_SELCHANGE(IDC_COMBO_LEN, OnSelchangeComboLen)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_PDOW, OnButtonPdow)
	ON_BN_CLICKED(IDC_BUTTON_PDOR, OnButtonPdor)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPDO_ProtocolDlg message handlers
BYTE SLOT=0;
BYTE BAUD=0;
BYTE NODE=1;
BYTE LEN=8;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;

void CPDO_ProtocolDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_pdow.EnableWindow(FALSE);
		m_btn_pdor.EnableWindow(FALSE);
		m_btn_clear.EnableWindow(FALSE);
		m_cobid.EnableWindow(FALSE);
		m_len.EnableWindow(FALSE);
		m_d0.EnableWindow(FALSE);
		m_d1.EnableWindow(FALSE);
		m_d2.EnableWindow(FALSE);
		m_d3.EnableWindow(FALSE);
		m_d4.EnableWindow(FALSE);
		m_d5.EnableWindow(FALSE);
		m_d6.EnableWindow(FALSE);
		m_d7.EnableWindow(FALSE);
	}
	else{
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_pdow.EnableWindow(TRUE);
		m_btn_pdor.EnableWindow(TRUE);
		m_btn_clear.EnableWindow(TRUE);
		m_cobid.EnableWindow(TRUE);
		m_len.EnableWindow(TRUE);
		m_d0.EnableWindow(TRUE);
		m_d1.EnableWindow(TRUE);
		m_d2.EnableWindow(TRUE);
		m_d3.EnableWindow(TRUE);
		m_d4.EnableWindow(TRUE);
		m_d5.EnableWindow(TRUE);
		m_d6.EnableWindow(TRUE);
		m_d7.EnableWindow(TRUE);
	}
}

BOOL CPDO_ProtocolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_slot.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_addnode.EnableWindow(FALSE);
	
	Enable_Disable(FALSE);

	m_slot.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);
	m_len.SetCurSel(7);
	m_cobid.LimitText(3);
	m_d0.LimitText(2);
	m_d1.LimitText(2);
	m_d2.LimitText(2);
	m_d3.LimitText(2);
	m_d4.LimitText(2);
	m_d5.LimitText(2);
	m_d6.LimitText(2);
	m_d7.LimitText(2);
	m_cobid.SetWindowText(_T("201"));
	m_d0.SetWindowText(_T("01"));
	m_d1.SetWindowText(_T("23"));
	m_d2.SetWindowText(_T("45"));
	m_d3.SetWindowText(_T("67"));
	m_d4.SetWindowText(_T("89"));
	m_d5.SetWindowText(_T("AB"));
	m_d6.SetWindowText(_T("CD"));
	m_d7.SetWindowText(_T("EF"));
	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CPDO_ProtocolDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_CHAR)
	{
		if( ((pMsg->wParam >= 0x30) && (pMsg->wParam <= 0x39)) || 
			((pMsg->wParam >= 0x41) && (pMsg->wParam <= 0x46)) ||
			((pMsg->wParam >= 0x61) && (pMsg->wParam <= 0x66)) ||
			 (pMsg->wParam == 0x08) ){
		}
		else{
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CPDO_ProtocolDlg::OnSelchangeComboSlot() 
{
	// TODO: Add your control notification handler code here
	SLOT = m_slot.GetCurSel();
}

void CPDO_ProtocolDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CPDO_ProtocolDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;
}

void CPDO_ProtocolDlg::OnSelchangeComboLen() 
{
	// TODO: Add your control notification handler code here
	LEN = m_len.GetCurSel()+1;
}

void CPDO_ProtocolDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_InitMaster(SLOT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_addnode.EnableWindow(TRUE);
	}
}

void CPDO_ProtocolDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	KillTimer(123);

	Sleep(100);

	ret = I8123_ShutdownMaster(SLOT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
		SetTimer(123,100,NULL);
	}
	else{
		m_slot.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);

		Enable_Disable(FALSE);
	}
}

void CPDO_ProtocolDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_AddNode(SLOT, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_node.EnableWindow(FALSE);

		Enable_Disable(TRUE);

		SetTimer(123,100,NULL);
	}
}

void CPDO_ProtocolDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_RemoveNode(SLOT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		KillTimer(123);

		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_node.EnableWindow(TRUE);

		Enable_Disable(FALSE);
	}
}

void CPDO_ProtocolDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	m_pdolist.ResetContent();
}

void CPDO_ProtocolDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer(123);

	Sleep(100);

	I8123_ShutdownMaster(SLOT);
}

void CPDO_ProtocolDlg::OnButtonPdow() 
{
	WORD i;
	CString DataStr, TempStr;
	wchar_t *end_str;
	WORD n_COBID;
	BYTE n_DATA[8];
	// TODO: Add your control notification handler code here

	m_cobid.GetWindowText(TempStr);
	n_COBID = (WORD)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_d0.GetWindowText(TempStr);
	n_DATA[0] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_d1.GetWindowText(TempStr);
	n_DATA[1] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_d2.GetWindowText(TempStr);
	n_DATA[2] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_d3.GetWindowText(TempStr);
	n_DATA[3] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_d4.GetWindowText(TempStr);
	n_DATA[4] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_d5.GetWindowText(TempStr);
	n_DATA[5] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_d6.GetWindowText(TempStr);
	n_DATA[6] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_d7.GetWindowText(TempStr);
	n_DATA[7] = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	ret = I8123_PDOWrite(SLOT, n_COBID, 0, LEN, n_DATA, BlockMode);
	if(ret){
		errstr.Format(_T("PDO Write Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("%03X: "),n_COBID);
		
		for(i=0;i<LEN;i++){
			DataStr.Format(_T("%s%02X "),DataStr,n_DATA[i]);
		}

		DataStr.Format(_T("%s: Write OK"),DataStr);

		m_pdolist.AddString(DataStr);
	}
}

void CPDO_ProtocolDlg::OnButtonPdor() 
{
	WORD i;
	CString DataStr, TempStr;
	wchar_t *end_str;
	BYTE RData[8],RLen;
	WORD n_COBID;
	// TODO: Add your control notification handler code here

	m_cobid.GetWindowText(TempStr);
	n_COBID = (WORD)wcstol(TempStr.AllocSysString(),&end_str,16);

	ret = I8123_PDORemote(SLOT, n_COBID, &RLen, RData, BlockMode);
	if(ret){
		errstr.Format(_T("PDO Remote Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("%03X: "),n_COBID);
		
		for(i=0;i<RLen;i++){
			DataStr.Format(_T("%s%02X "),DataStr,RData[i]);
		}

		DataStr.Format(_T("%s: Remote OK"),DataStr);

		m_pdolist.AddString(DataStr);
	}
}

void CPDO_ProtocolDlg::OnTimer(UINT nIDEvent) 
{
	WORD Ret,i;
	BYTE IsNew, DLen, Data[8];
	CString DataStr;
	// TODO: Add your message handler code here and/or call default
	
	// Check PDO data of default TxPDO  
	Ret = I8123_GetPDOLastData(SLOT, 0x180+NODE, &IsNew, &DLen, Data, BlockMode);
	if((!Ret)&&(IsNew)){
		DataStr.Format(_T("%03X: "),0x180+NODE);
		
		for(i=0;i<DLen;i++){
			DataStr.Format(_T("%s%02X "),DataStr,Data[i]);
		}

		DataStr.Format(_T("%s: Get TxPDO"),DataStr);

		m_pdolist.AddString(DataStr);
	}

	Ret = I8123_GetPDOLastData(SLOT, 0x280+NODE, &IsNew, &DLen, Data, BlockMode);
	if((!Ret)&&(IsNew)){
		DataStr.Format(_T("%03X: "),0x280+NODE);
		
		for(i=0;i<DLen;i++){
			DataStr.Format(_T("%s%02X "),DataStr,Data[i]);
		}

		DataStr.Format(_T("%s: Get TxPDO"),DataStr);

		m_pdolist.AddString(DataStr);
	}

	Ret = I8123_GetPDOLastData(SLOT, 0x380+NODE, &IsNew, &DLen, Data, BlockMode);
	if((!Ret)&&(IsNew)){
		DataStr.Format(_T("%03X: "),0x380+NODE);
		
		for(i=0;i<DLen;i++){
			DataStr.Format(_T("%s%02X "),DataStr,Data[i]);
		}

		DataStr.Format(_T("%s: Get TxPDO"),DataStr);

		m_pdolist.AddString(DataStr);
	}

	Ret = I8123_GetPDOLastData(SLOT, 0x480+NODE, &IsNew, &DLen, Data, BlockMode);
	if((!Ret)&&(IsNew)){
		DataStr.Format(_T("%03X: "),0x480+NODE);
		
		for(i=0;i<DLen;i++){
			DataStr.Format(_T("%s%02X "),DataStr,Data[i]);
		}

		DataStr.Format(_T("%s: Get TxPDO"),DataStr);

		m_pdolist.AddString(DataStr);
	}

	CDialog::OnTimer(nIDEvent);
}
