// SDO_ReadDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SDO_Read.h"
#include "SDO_ReadDlg.h"
#include "..\lib\i8123w.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSDO_ReadDlg dialog

CSDO_ReadDlg::CSDO_ReadDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSDO_ReadDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSDO_ReadDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSDO_ReadDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSDO_ReadDlg)
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_btn_clear);
	DDX_Control(pDX, IDC_COMBO_SLOT, m_slot);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_READSDO, m_btn_sdoread);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
	DDX_Control(pDX, IDC_LIST_SDOLIST, m_sdolist);
	DDX_Control(pDX, IDC_EDIT_SUBINDEX, m_subindex);
	DDX_Control(pDX, IDC_EDIT_INDEX, m_index);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSDO_ReadDlg, CDialog)
	//{{AFX_MSG_MAP(CSDO_ReadDlg)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_READSDO, OnButtonReadsdo)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_CBN_SELCHANGE(IDC_COMBO_SLOT, OnSelchangeComboSlot)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDO_ReadDlg message handlers
BYTE SLOT=0;
BYTE BAUD=0;
BYTE NODE=1;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;

void CSDO_ReadDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_sdoread.EnableWindow(FALSE);
		m_btn_clear.EnableWindow(FALSE);
		m_index.EnableWindow(FALSE);
		m_subindex.EnableWindow(FALSE);
	}
	else{
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_sdoread.EnableWindow(TRUE);
		m_btn_clear.EnableWindow(TRUE);
		m_index.EnableWindow(TRUE);
		m_subindex.EnableWindow(TRUE);
	}
}

BOOL CSDO_ReadDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here

	m_slot.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_addnode.EnableWindow(FALSE);

	Enable_Disable(FALSE);

	m_slot.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);
	m_index.LimitText(4);
	m_subindex.LimitText(2);
	m_index.SetWindowText(_T("1000"));
	m_subindex.SetWindowText(_T("00"));
	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CSDO_ReadDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_CHAR)
	{
		if( ((pMsg->wParam >= 0x30) && (pMsg->wParam <= 0x39)) || 
			((pMsg->wParam >= 0x41) && (pMsg->wParam <= 0x46)) ||
			((pMsg->wParam >= 0x61) && (pMsg->wParam <= 0x66)) ||
			 (pMsg->wParam == 0x08) ){
		}
		else{
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CSDO_ReadDlg::OnSelchangeComboSlot() 
{
	// TODO: Add your control notification handler code here
	SLOT = m_slot.GetCurSel();
}

void CSDO_ReadDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CSDO_ReadDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;
}

void CSDO_ReadDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_InitMaster(SLOT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		if(BAUD == 0) I8123_SetFunctionTimeout(SLOT, 3000);

		m_slot.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_addnode.EnableWindow(TRUE);
	}
}

void CSDO_ReadDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_ShutdownMaster(SLOT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);

		Enable_Disable(FALSE);
	}
}

void CSDO_ReadDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_AddNode(SLOT, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_node.EnableWindow(FALSE);

		Enable_Disable(TRUE);
	}
}

void CSDO_ReadDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_RemoveNode(SLOT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_node.EnableWindow(TRUE);

		Enable_Disable(FALSE);
	}
}

void CSDO_ReadDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	m_sdolist.ResetContent();
}

void CSDO_ReadDlg::OnButtonReadsdo() 
{
	WORD i, n_INDEX;
	DWORD RDLen;
	BYTE RData[50], n_SUBINDEX;
	CString DataStr, TempStr;
	wchar_t *end_str;
	// TODO: Add your control notification handler code here

	m_index.GetWindowText(TempStr);
	n_INDEX = (WORD)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_subindex.GetWindowText(TempStr);
	n_SUBINDEX = (BYTE)wcstol(TempStr.AllocSysString(),&end_str,16);

	ret = I8123_SDOReadData(SLOT, NODE, n_INDEX, n_SUBINDEX, &RDLen, RData, BlockMode);
	if(ret && ret != CPM_Abort){
		errstr.Format(_T("SDO Read Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("%04X-%02X: "),n_INDEX, n_SUBINDEX);
		for(i=0;i<RDLen;i++){
			DataStr.Format(_T("%s%02X "),DataStr,RData[i]);
		}

		if(ret == CPM_Abort) DataStr.Format(_T("%s: Read Abort"),DataStr);

		m_sdolist.AddString(DataStr);
	}
}

void CSDO_ReadDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	I8123_ShutdownMaster(SLOT);
}
