// Scan_NodeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Scan_Node.h"
#include "Scan_NodeDlg.h"
#include "..\lib\i8123w.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScan_NodeDlg dialog

CScan_NodeDlg::CScan_NodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScan_NodeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScan_NodeDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScan_NodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScan_NodeDlg)
	DDX_Control(pDX, IDC_LIST_NODELIST, m_nodelist);
	DDX_Control(pDX, IDC_COMBO_SLOT, m_slot);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_SCAN, m_btn_scan);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CScan_NodeDlg, CDialog)
	//{{AFX_MSG_MAP(CScan_NodeDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_SLOT, OnSelchangeComboSlot)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_SCAN, OnButtonScan)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScan_NodeDlg message handlers
BYTE SLOT=0;
BYTE BAUD=0;
BYTE NODE=0;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;

BOOL CScan_NodeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	m_slot.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_shutdown.EnableWindow(FALSE);
	m_btn_scan.EnableWindow(FALSE);
	m_btn_addnode.EnableWindow(FALSE);
	m_btn_removenode.EnableWindow(FALSE);

	m_slot.SetCurSel(0);
	m_baud.SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CScan_NodeDlg::OnSelchangeComboSlot() 
{
	// TODO: Add your control notification handler code here
	SLOT = m_slot.GetCurSel();
}

void CScan_NodeDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CScan_NodeDlg::OnSelchangeComboNode() 
{
	WORD Node_Index;
	TCHAR T_TempStr[10];
	WORD *end_str;
	// TODO: Add your control notification handler code here

	if(!m_node.GetCount()) return;

	Node_Index = m_node.GetCurSel();

	// Convert text to Node ID number
	m_node.GetLBText(Node_Index,T_TempStr);
	NODE = (BYTE)wcstoul(T_TempStr,&end_str,10);
}

void CScan_NodeDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_InitMaster(SLOT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_btn_initial.EnableWindow(FALSE);
		m_btn_initial.ShowWindow(SW_HIDE);

		m_btn_shutdown.EnableWindow(TRUE);
		m_btn_scan.EnableWindow(TRUE);
	}
}

void CScan_NodeDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_ShutdownMaster(SLOT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_slot.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_btn_initial.EnableWindow(TRUE);
		m_btn_initial.ShowWindow(SW_SHOW);

		m_node.EnableWindow(FALSE);

		m_btn_shutdown.EnableWindow(FALSE);
		m_btn_scan.EnableWindow(FALSE);
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_removenode.EnableWindow(FALSE);
	}
}

void CScan_NodeDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_AddNode(SLOT, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		BYTE NodeList[16];
		BYTE Flag, Node=0;
		WORD i,j;
		CString NodeNumber;

		ret = I8123_GetNodeList(SLOT, NodeList, BlockMode);
		if(ret){
			errstr.Format(_T("Node List Get Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}
		else{
			m_nodelist.ResetContent();
			// NodeList[0] is node 0 ~ 7
			// NodeList[1] is node 8 ~ 15
			// ...
			// NodeList[15] is node 120 ~ 127
			for(i=0;i<16;i++){
				Flag=1;
				for(j=0;j<8;j++){
					if(NodeList[i] & Flag){
						NodeNumber.Format(_T("Node %03d under controll"),Node);
						m_nodelist.AddString(NodeNumber);
					}
					Node++;
					Flag = Flag << 1;
				}
			}
		}
	}
}

void CScan_NodeDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = I8123_RemoveNode(SLOT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		BYTE NodeList[16];
		BYTE Flag, Node=0;
		WORD i,j;
		CString NodeNumber;

		ret = I8123_GetNodeList(SLOT, NodeList, BlockMode);
		if(ret){
			errstr.Format(_T("Node List Get Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}
		else{
			m_nodelist.ResetContent();
			// NodeList[0] is node 0 ~ 7
			// NodeList[1] is node 8 ~ 15
			// ...
			// NodeList[15] is node 120 ~ 127
			for(i=0;i<16;i++){
				Flag=1;
				for(j=0;j<8;j++){
					if(NodeList[i] & Flag){
						NodeNumber.Format(_T("Node %03d under controll"),Node);
						m_nodelist.AddString(NodeNumber);
					}
					Node++;
					Flag = Flag << 1;
				}
			}
		}
	}
}

void CScan_NodeDlg::OnButtonScan() 
{
	BYTE NodeList[16];
	BYTE Flag, Node=0;
	WORD i,j;
	CString NodeNumber;
	// TODO: Add your control notification handler code here

	// Set function timeout to 3000 ms
	I8123_SetFunctionTimeout(SLOT, 3000);

	// Scan total node to check witch nodes are on the CANopen bus
	ret = I8123_ScanNode(SLOT, 0, 0, NodeList, BlockMode);
	if(ret){
		errstr.Format(_T("Node Scan Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		// Set function timeout to 1000 ms (default value)
		I8123_SetFunctionTimeout(SLOT, 1000);

		m_node.ResetContent();
		// NodeList[0] is node 0 ~ 7
		// NodeList[1] is node 8 ~ 15
		// ...
		// NodeList[15] is node 120 ~ 127
		for(i=0;i<16;i++){
			Flag=1;
			for(j=0;j<8;j++){
				if(NodeList[i] & Flag){
					NodeNumber.Format(_T("%03d"),Node);
					m_node.AddString(NodeNumber);
				}
				Node++;
				Flag = Flag << 1;
			}
		}

		if(m_node.GetCount()){
			TCHAR T_TempStr[10];
			WORD *end_str;

			m_node.EnableWindow(TRUE);
			m_btn_addnode.EnableWindow(TRUE);
			m_btn_removenode.EnableWindow(TRUE);

			// Convert text to Node ID number
			m_node.GetLBText(0,T_TempStr);
			NODE = (BYTE)wcstoul(T_TempStr,&end_str,10);
		}
		else{
			m_node.AddString(_T("None Slave!"));
			m_node.EnableWindow(FALSE);
			m_btn_addnode.EnableWindow(FALSE);
			m_btn_removenode.EnableWindow(FALSE);

			NODE = 0;
		}

		m_node.SetCurSel(0);
	}
}
